const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class OffersDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const offers = await db.offers.create(
      {
        id: data.id || undefined,

        comp_package: data.comp_package || null,
        target_start_date: data.target_start_date || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await offers.setApplication(data.application || null, {
      transaction,
    });

    await offers.setOrganizations(data.organizations || null, {
      transaction,
    });

    return offers;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const offersData = data.map((item, index) => ({
      id: item.id || undefined,

      comp_package: item.comp_package || null,
      target_start_date: item.target_start_date || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const offers = await db.offers.bulkCreate(offersData, { transaction });

    // For each item created, replace relation files

    return offers;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const offers = await db.offers.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.comp_package !== undefined)
      updatePayload.comp_package = data.comp_package;

    if (data.target_start_date !== undefined)
      updatePayload.target_start_date = data.target_start_date;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await offers.update(updatePayload, { transaction });

    if (data.application !== undefined) {
      await offers.setApplication(
        data.application,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await offers.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return offers;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const offers = await db.offers.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of offers) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of offers) {
        await record.destroy({ transaction });
      }
    });

    return offers;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const offers = await db.offers.findByPk(id, options);

    await offers.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await offers.destroy({
      transaction,
    });

    return offers;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const offers = await db.offers.findOne({ where }, { transaction });

    if (!offers) {
      return offers;
    }

    const output = offers.get({ plain: true });

    output.application = await offers.getApplication({
      transaction,
    });

    output.organizations = await offers.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.applications,
        as: 'application',

        where: filter.application
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.application
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  status: {
                    [Op.or]: filter.application
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.comp_package) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('offers', 'comp_package', filter.comp_package),
        };
      }

      if (filter.target_start_dateRange) {
        const [start, end] = filter.target_start_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            target_start_date: {
              ...where.target_start_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            target_start_date: {
              ...where.target_start_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.offers.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('offers', 'comp_package', query),
        ],
      };
    }

    const records = await db.offers.findAll({
      attributes: ['id', 'comp_package'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['comp_package', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.comp_package,
    }));
  }
};
